// Copyright (c) 2003 Charles Samuels <charles@kde.org>
// See the file COPYING for redistribution terms.

#ifndef OBLIQUE_H
#define OBLIQUE_H

#include <noatun/playlist.h>
#include <noatun/plugin.h>
#include "query.h"
#include "kdatacollection.h"

class Tree;
class Base;
class Selector;

class Oblique : public Plugin, public Playlist
{
	Tree *mView;
	Base *mBase;
	Query mQuery;
	QString mFileOfQuery;
	bool mVisible;
	Selector *mSelector;
	KDataCollection mSchemaCollection;

public:
	Oblique();
	~Oblique();

	Query *query() { return &mQuery; }

	KDataCollection &schemaCollection() { return mSchemaCollection; }

	/**
	 * load the query by its name in the KDataCollection, and save the name
	 * for @ref fileOfQuery()
	 **/
	void loadQuery(const QString &name);

	QString fileOfQuery() const { return mFileOfQuery; }

	virtual void reset();
	virtual void clear();
	virtual void addFile(const KURL&, bool play=false);
	virtual PlaylistItem next();
	virtual PlaylistItem previous();
	virtual PlaylistItem current();
	virtual void setCurrent(const PlaylistItem &);
	virtual PlaylistItem getFirst() const;
	virtual PlaylistItem getAfter(const PlaylistItem &item) const;
	virtual bool listVisible() const;
	virtual void showList();
	virtual void hideList();

	virtual Playlist *playlist() { return this; }
};


#endif
